scene = Core.class(Sprite)

function scene:init()
	local bg = Bitmap.new(Texture.new("gideros_mobile.png", true))
	bg:setAnchorPoint(0.5, 0.5)
	bg:setPosition(application:getContentWidth()/2, application:getContentHeight()/2)
	self:addChild(bg)
	
	self:addEventListener("enterEnd", self.onEnterEnd, self)
end

function scene:onEnterEnd()
	local function onMouseDown(self, event)
		if self:hitTestPoint(event.x, event.y) then
			self.isFocus = true
			self.startX = event.x
			self.initX = self:getX()
			self.x0 = event.x
	
			event:stopPropagation()
		end
	end
	
	local function onMouseMove(self, event)
		if self.isFocus then
			local dx = event.x - self.x0
			
			self:setX(self:getX() + dx)
	
			self.x0 = event.x
	
			event:stopPropagation()
		end
	end
	
	local function onMouseUp(self, event)
		if self.isFocus then
			local back = false
			if self.startX < self.x0 - 10 then
				if curScene > 1 then
					curScene = curScene - 1
					sceneManager:changeScene("scene", 1, SceneManager.moveFromLeft) 
				else
					back = true
				end
			elseif self.startX > self.x0 + 10 then
				if curScene < scenes then
					curScene = curScene + 1
					sceneManager:changeScene("scene", 1, SceneManager.moveFromRight) 
				else
					back = true
				end
			else
				back = true
			end
			if back then
				GTween.new(self, 0.1, {x = self.initX})
			end
			self.isFocus = false
			event:stopPropagation()
		end
	end
	
	self:addEventListener(Event.MOUSE_DOWN, onMouseDown, self)
	self:addEventListener(Event.MOUSE_MOVE, onMouseMove, self)
	self:addEventListener(Event.MOUSE_UP, onMouseUp, self)
end